<?php	
/*
Plesk DynDNS Control Panel (Version see version.php) - GUI for Plesk to build and administrate a DynDNS Service

Copyright (C) [2013 [Matthias Hackbarth / www.haggybear.de]

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.
*/

class Dns {

        var $plesk_domain;
        
        var $credentials;
        
        var $allDyns;
        
        var $noDyns;
        
        var $plesk_db_conn;

	function __construct($dom,$cred,$plesk_db_conn){
		$this->plesk_domain = $dom;
		$this->credentials = $cred;
    $this->plesk_db_conn = $plesk_db_conn;
	}

	function __destruct(){
	}

	function setSqlEntry($host,$ip){
		mysqli_query($this->plesk_db_conn,'UPDATE dns_recs SET displayVal = "'.$ip.'", val = "'.$ip.'" where host ="'.$host.'." and type = "A"');
	}

	function setRefreshDns(){
		exec('sh/wrapper "1" "refreshdns" "'.PSA_PATH.'bin/dns" "'.$this->plesk_domain.'"');
	}

	function setCreateDns($sub,$dom,$vhostPath){
		exec('sh/wrapper "1" "createdns" "'.PSA_PATH.'bin/subdomain" "dynupd.'.$sub.'" "'.$dom.'" "'.PSA_PATH.'admin/htdocs'.DCP_PATH.'/dynupd" "'.PSA_PATH.'" "'.$vhostPath.'"');
	}

	function setDeleteDns(){   
		exec('sh/wrapper "1" "deletedns" "'.PSA_PATH.'bin/domain" "dynupd.'.$_POST["hostname"].'"');
	}

	function getDnsIps(){
		$result = mysqli_query($this->plesk_db_conn,"SELECT ip_address from IP_Addresses");
		while($data = mysqli_fetch_object($result)){
			$ips[] = $data->ip_address;
			}
		return $ips;
	}

	function getAllDomainsAndAliases($domId){
                $doms = array($this->plesk_domain);
                $masterDomains = array($this->plesk_domain);
		$domainIds[] = $domId;
		$domYes = array();
		$domNo = array();
		$ips = array();

		$ips = $this->getDnsIps();
		$hasDomAlias = false;

                $domAliasTable = "domainaliases";

                if(PSA_VERSION >= 12) $domAliasTable = "domain_aliases";		
                $result = mysqli_query($this->plesk_db_conn,"SELECT id,name FROM `domains` WHERE webspace_id = (SELECT id FROM `domains` WHERE name = '".$this->plesk_domain."') and parentDomainId = 0");
                while($data = mysqli_fetch_object($result)){	
		      $doms[] = $data->name;
                      $masterDomains[] = $data->name;
                      $domainIds[] = $data->id;
		      }
  		if(mysqli_num_rows(mysqli_query($this->plesk_db_conn,"SHOW TABLES LIKE '$domAliasTable'"))>0) $hasDomAlias = true;
		$result = mysqli_query($this->plesk_db_conn,"SELECT a.id, a.name, b.id FROM psa.$domAliasTable AS a, psa.domains AS b WHERE b.name in ('".implode("','",$doms)."') AND b.id = a.dom_id");
		if($result && $hasDomAlias){
			while($data = mysqli_fetch_object($result)){	
				$doms[] = $data->name;
				}
		}
		
		for($i=0;$i<count($doms);$i++){
			$out = array();
			exec('sh/wrapper "1" "checkdns" "'.$doms[$i].'"',$out);
			for($ii=0;$ii<count($out);$ii++){
			    if(stristr($out[$ii],"nameserver")){
				$tmp = explode("=",$out[$ii]);
				break;
				}
			    }
			$ip = gethostbyname(substr(trim($tmp[1]),0,strlen(trim($tmp[1]))-1));

			if(!in_array($ip,$ips))$domNo[] = $doms[$i];
		}

		$result = mysqli_query($this->plesk_db_conn,"SELECT name FROM domains WHERE parentDomainId in (".implode(",",$domainIds).")");
		if($result){
		    while($data = mysqli_fetch_object($result)){
		    if(stristr($data->name,"dynupd.")) continue;
		    for($i=0;$i<count($doms);$i++){
                	$allDyns[] = str_replace($masterDomains,"",$data->name).$doms[$i].".";
			}
		    for($i=0;$i<count($domNo);$i++){
                        $noDyns[] = str_replace($masterDomains,"",$data->name).$domNo[$i].".";
                        }
            	  }
            	}
                $this->allDyns = $allDyns;
                $this->noDyns = $noDyns;
                }
}
?>
